def gb
pipeline{
    agent any
    stages{

    stage("init"){
                steps(){
                script{
                      gb = load "GrouvyScript.groovy"
                      }
                }
        }

    stage("incrementAppVersion "){
                steps(){
                script{
                      sh 'mvn build-helper:parse-version versions:set \
                      -DnewVersion=\\\${parsedVersion.majorVersion}.\\\${parsedVersion.minorVersion}.\\\${parsedVersion.newtIncrementVersion} \
                      versions:commit'
                     def matcher = readFile('pom.xml') =~ '<version>(.+)</version>'
                      def version = matcher[1][1]
                      env.IMAGE_NAME = "$version-$BUILD_NUMBER"
                      }
                }
        }
    stage("testApp"){
                
                steps(){
                    script{
                    gb.test()
                    }
                }
        }
    stage("build JarFile"){

                when{
                    expression{
                        BRANCH_NAME=='main'
                            }
                    }
                steps(){
                script{
                   gb.buildJarFile()
                   }
                }
        }

    stage("build dockerImage "){
                
                when{
                    expression{
                        BRANCH_NAME=='main'
                                            }
                }
            steps(){
                script{
                   gb.buildDockerImage()
                }
            }
    }

    stage("deploy"){

           when{
                    expression{
                        BRANCH_NAME=='main'
                  }
                }
            steps(){
                script{
                   gb.deploy()
                }
        }
   }
   stage("commit to remote repo"){
     when{
                    expression{
                        BRANCH_NAME=='main1'
                  }
                }
    steps(){
        script{
            withCredentials([usernamePassword(credentialsId: 'gitlab-credentials', passwordVariable: 'PASS', usernameVariable: 'USER')]){
            //  sh 'git config --global user.email "jenkins@gmail.com"'
            //  sh 'git config --global user.name "jenkins"'

            // sh 'git status'
            // sh 'git branch'
            // sh 'git config --list'
            // sh "git remote set-url origin https://${USER}:${PASS}@gitlab.com/ayoub.bahaddouayoub/java-jenkins-versioning.git"
            // sh 'git add .'
            // sh 'git commit -m "ci:version bump"'
            // sh 'git push origin HEAD:main'
            }
        }  
     }
   }
  }
}
